/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for ErrorProto.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ErrorProto extends GenericJson {

  /**
   * Debugging information. This property is internal to Google and should not be used.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String debugInfo;

  /**
   * Specifies where the error occurred, if present.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String location;

  /**
   * A human-readable description of the error.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String message;

  /**
   * A short error code that summarizes the error.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String reason;

  /**
   * Debugging information. This property is internal to Google and should not be used.
   * The value returned may be {@code null}.
   */
  public String getDebugInfo() {
    return debugInfo;
  }

  /**
   * Debugging information. This property is internal to Google and should not be used.
   * The value set may be {@code null}.
   */
  public ErrorProto setDebugInfo(String debugInfo) {
    this.debugInfo = debugInfo;
    return this;
  }

  /**
   * Specifies where the error occurred, if present.
   * The value returned may be {@code null}.
   */
  public String getLocation() {
    return location;
  }

  /**
   * Specifies where the error occurred, if present.
   * The value set may be {@code null}.
   */
  public ErrorProto setLocation(String location) {
    this.location = location;
    return this;
  }

  /**
   * A human-readable description of the error.
   * The value returned may be {@code null}.
   */
  public String getMessage() {
    return message;
  }

  /**
   * A human-readable description of the error.
   * The value set may be {@code null}.
   */
  public ErrorProto setMessage(String message) {
    this.message = message;
    return this;
  }

  /**
   * A short error code that summarizes the error.
   * The value returned may be {@code null}.
   */
  public String getReason() {
    return reason;
  }

  /**
   * A short error code that summarizes the error.
   * The value set may be {@code null}.
   */
  public ErrorProto setReason(String reason) {
    this.reason = reason;
    return this;
  }

}
